package dev.fitko.fitconnect.api.config.defaults;

import java.net.URI;

public enum SchemaConfig {

    SCHEMA_BASE_URL(URI.create("https://schema.fitko.de/fit-connect/")),

    SET_SCHEMA_PATH(SCHEMA_BASE_URL.schemaUri.resolve("set-payload/"), "/set-payload.schema.json"),
    METADATA_SCHEMA_PATH(SCHEMA_BASE_URL.schemaUri.resolve("metadata/"), "/metadata.schema.json"),

    DESTINATION_SCHEMA_VERSION(SCHEMA_BASE_URL.schemaUri.resolve("xzufi/destination.schema.json"));

    private final URI schemaUri;
    private final String filename;

    SchemaConfig(final URI schemaUri, String filename) {
        this.schemaUri = schemaUri;
        this.filename = filename;
    }

    SchemaConfig(final URI schemaUri) {
        this.schemaUri = schemaUri;
        filename = "";
    }

    public URI getSchemaUriForVersion(String version) {
        return URI.create(schemaUri + version + filename);
    }

    public URI getSchemaUri() {
        return schemaUri;
    }
}
