package dev.fitko.fitconnect.api.domain.model.metadata;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
public class AdditionalReferenceInfo {

    @JsonProperty("senderReference")
    private String senderReference;

    @JsonProperty("applicationDate")
    private String applicationDate;

    public static Builder builder() {
        return new Builder();
    }

    public static class Builder {
        private String senderReference;
        private String applicationDate;

        public Builder withSenderReference(final String senderReference) {
            this.senderReference = senderReference;
            return this;
        }

        public Builder withApplicationDate(final String applicationDate) {
            this.applicationDate = applicationDate;
            return this;
        }

        public AdditionalReferenceInfo build() {
            return new AdditionalReferenceInfo(senderReference, applicationDate);
        }
    }
}


