package dev.fitko.fitconnect.api.domain.model.metadata;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import dev.fitko.fitconnect.api.domain.model.metadata.payment.PaymentInformation;
import dev.fitko.fitconnect.api.domain.model.reply.replychannel.ReplyChannel;
import lombok.AllArgsConstructor;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.List;

@Setter
@EqualsAndHashCode
@AllArgsConstructor
@NoArgsConstructor
@JsonInclude(JsonInclude.Include.NON_NULL)
public class Metadata {

    @Getter
    @JsonProperty("$schema")
    private String schema;

    @Getter
    private ContentStructure contentStructure = new ContentStructure();

    @Getter
    private List<AuthenticationInformation> authenticationInformation;

    @Getter
    private PaymentInformation paymentInformation;

    @Getter
    private ReplyChannel replyChannel;

    @Getter
    private AdditionalReferenceInfo additionalReferenceInfo;
}
