package dev.fitko.fitconnect.api.domain.model.metadata.attachment;

import lombok.AllArgsConstructor;
import lombok.Data;

import java.util.UUID;

@Data
@AllArgsConstructor
public class AttachmentForValidation {

    private UUID attachmentId;
    private String metadataHash;
    private byte[] decryptedData;
    private String encryptedData;
    private ApiAttachment attachmentMetadata;

    public AttachmentForValidation(final ApiAttachment attachmentMetadata, final String encryptedData, final byte[] decryptedData){
        attachmentId = attachmentMetadata.getAttachmentId();
        metadataHash = attachmentMetadata.getHash().getContent();
        this.attachmentMetadata = attachmentMetadata;
        this.decryptedData = decryptedData;
        this.encryptedData = encryptedData;
    }
}
