package dev.fitko.fitconnect.api.domain.model.submission;

import dev.fitko.fitconnect.api.domain.model.event.authtags.AuthenticationTags;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;

import java.util.UUID;

@Getter
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class SentSubmission {

    private UUID destinationId;
    private UUID submissionId;
    private UUID caseId;
    private AuthenticationTags authenticationTags;

    public SentSubmission(final UUID destinationId, final UUID caseId, final UUID submissionId) {
        this.destinationId = destinationId;
        this.caseId = caseId;
        this.submissionId = submissionId;
        authenticationTags = null;
    }
}
