package dev.fitko.fitconnect.api.domain.sender.steps.unencrypted;

import java.net.URI;

public interface DataStep {

    /**
     * Set JSON data as string.
     *
     * @param data      json string
     * @param schemaUri specifies the schema that will be used to validate the data
     * @return next step to set optional properties
     */
    OptionalPropertiesStep setJsonData(String data, URI schemaUri);

    /**
     * Set XML data as string.
     *
     * @param data      xml string
     * @param schemaUri specifies the schema that will be used to validate the data
     * @return next step to set optional properties
     */
    OptionalPropertiesStep setXmlData(String data, URI schemaUri);
}
