package dev.fitko.fitconnect.api.domain.subscriber.steps;

import java.net.URI;

public interface ReplyDataStep {

    /**
     * Set JSON data as string.
     *
     * @param data      json string
     * @param schemaUri specifies the schema that will be used to validate the data
     * @return next step to set additional properties
     */
    OptionalReplyPropertiesStep setJsonData(String data, URI schemaUri);

    /**
     * Set XML data as string.
     *
     * @param data      xml string
     * @param schemaUri specifies the schema that will be used to validate the data
     * @return next step to set additional properties
     */
    OptionalReplyPropertiesStep setXmlData(String data, URI schemaUri);
}
