package dev.fitko.fitconnect.api.services.routing;

import dev.fitko.fitconnect.api.domain.model.route.Route;
import dev.fitko.fitconnect.api.domain.validation.ValidationResult;

import java.util.List;

/**
 * Service to verify the validity of routing-related data.
 */
public interface RoutingVerificationService {

    /**
     * Verifies host url, self-service portal signature and DVDV signature of the provided {@link Route}.
     *
     * @param routes                     list of routes to be verified
     * @param requestedServiceIdentifier requested service identifier to be checked if the route supports it
     * @param requestedRegion            requested service region to be checked if the routes supports it
     * @return {@link ValidationResult}, is ok if validation passes, has an error including an exception if the validation failed
     */
    ValidationResult validateRouteDestinations(List<Route> routes, String requestedServiceIdentifier, String requestedRegion);
}
